#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var generate_1 = require("./cli/generate");
var create_1 = require("./cli/create");
var update_1 = require("./cli/update");
var program = require('commander');
var version = require('../../package.json').version;
program
    .version(version)
    .option('-c, --create [type]', 'Create [type] host || app')
    .option('-u, --update [host]', 'Update [type] host || app')
    .option('-g, --generate', 'Generate Mooa App Config')
    .parse(process.argv);
if (program.create) {
    create_1.default(program);
}
if (program.update) {
    update_1.default(program);
}
if (program.generate) {
    generate_1.default(program);
}
if (!process.argv.slice(2).length || !process.argv.length) {
    program.outputHelp();
}
//# sourceMappingURL=cli.js.map