"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var app_helper_1 = require("./app.helper");
function createApplicationContainer(mooaApp) {
    var opts = mooaApp.appConfig;
    var el = document.querySelector(opts.selector);
    if (el) {
        return el;
    }
    el = document.createElement(opts.selector);
    if (opts.parentElement) {
        var parentEl = document.querySelector(opts.parentElement);
        if (parentEl) {
            parentEl.appendChild(el);
        }
        else {
            document.body.appendChild(el);
        }
    }
    else {
        document.body.appendChild(el);
    }
    return el;
}
exports.createApplicationContainer = createApplicationContainer;
function removeApplicationContainer(mooaApp) {
    var opts = mooaApp.appConfig;
    var el = document.querySelector(opts.selector);
    if (el && el !== null) {
        if (!('remove' in Element.prototype)) {
            Element.prototype.remove = function () {
                if (el && el.parentNode) {
                    el.parentNode.removeChild(el);
                }
            };
        }
        else {
            el.remove();
        }
    }
}
exports.removeApplicationContainer = removeApplicationContainer;
function createApplicationIframeContainer(mooaApp) {
    var opts = mooaApp.appConfig;
    var iframe = document.createElement('iframe');
    iframe.frameBorder = '';
    iframe.width = '100%';
    iframe.height = '100%';
    iframe.src = window.location + 'assets/iframe.html';
    iframe.id = generateIFrameID(mooaApp.appConfig.name);
    var el = document.createElement(opts.selector);
    if (opts.parentElement) {
        var parentEl = document.querySelector(opts.parentElement);
        if (parentEl) {
            parentEl.appendChild(iframe);
        }
    }
    else {
        document.body.appendChild(iframe);
    }
    var iframeEl = document.getElementById(iframe.id);
    iframeEl.contentWindow.document.write('<div></div>');
    iframeEl.contentWindow.document.body.appendChild(el);
    iframeEl.contentWindow.document.head.innerHTML =
        iframeEl.contentWindow.document.head.innerHTML + "<base href='/' />";
    iframeEl.contentWindow.mooa = {
        isSingleSpa: true
    };
}
exports.createApplicationIframeContainer = createApplicationIframeContainer;
function removeApplicationIframeContainer(mooaApp) {
    var iframeId = generateIFrameID(mooaApp.appConfig.name);
    var iframeEl = document.getElementById(iframeId);
    if (iframeEl) {
        if (!('remove' in Element.prototype)) {
            Element.prototype.remove = function () {
                if (iframeEl && iframeEl.parentNode) {
                    iframeEl.parentNode.removeChild(iframeEl);
                }
            };
        }
        else {
            iframeEl.remove();
        }
    }
}
exports.removeApplicationIframeContainer = removeApplicationIframeContainer;
function generateIFrameID(name) {
    return name + '_' + app_helper_1.hashCode(name);
}
exports.generateIFrameID = generateIFrameID;
//# sourceMappingURL=dom.utils.js.map