"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("./model/constants");
var load_1 = require("./lifecycles/load");
var bootstrap_1 = require("./lifecycles/bootstrap");
var mount_1 = require("./lifecycles/mount");
var status_helper_1 = require("./helper/status.helper");
var unload_1 = require("./lifecycles/unload");
var unmount_1 = require("./lifecycles/unmount");
var router_1 = require("./router");
var platform_1 = require("./platform/platform");
var app_helper_1 = require("./helper/app.helper");
var dom_utils_1 = require("./helper/dom.utils");
var apps = [];
window.mooa = window.mooa || {};
var Mooa = /** @class */ (function () {
    function Mooa(option) {
        this.started = false;
        window.mooa.instance = this;
        if (option) {
            window.mooa.option = option;
            window.mooa.debug = option.debug;
        }
        if (localStorage.getItem('mooa.debug') === 'true') {
            window.mooa.debug = true;
        }
        this.option = option;
    }
    Mooa.prototype.registerApplication = function (appName, appConfig, activeWhen, customProps) {
        if (customProps === void 0) { customProps = {}; }
        if (!activeWhen) {
            throw new Error("Lost Loader");
        }
        if (typeof activeWhen !== 'function') {
            throw new Error("The activeWhen argument must be a function");
        }
        if (this.option.parentElement) {
            appConfig.parentElement = this.option.parentElement;
        }
        if (this.option.urlPrefix) {
            appConfig.prefix = this.option.urlPrefix + '/' + appConfig.prefix;
        }
        var appOpt = {
            name: appName,
            appConfig: appConfig,
            activeWhen: activeWhen,
            status: constants_1.StatusEnum.NOT_LOADED,
            customProps: customProps
        };
        apps.push(appOpt);
        window.apps = apps;
    };
    Mooa.prototype.registerApplicationByLink = function (appName, link, activeWhen, customProps) {
        if (customProps === void 0) { customProps = {}; }
        if (!activeWhen) {
            throw new Error("Lost Loader");
        }
        if (typeof activeWhen !== 'function') {
            throw new Error("The activeWhen argument must be a function");
        }
        var appConfig = {
            name: appName,
            scripts: [],
            selector: "app-" + appName,
            baseScriptUrl: link,
            styles: [],
            parentElement: '',
            prefix: ''
        };
        if (this.option.parentElement) {
            appConfig.parentElement = this.option.parentElement;
        }
        if (this.option.urlPrefix) {
            appConfig.prefix = this.option.urlPrefix + '/' + appConfig.prefix;
        }
        var appOpt = {
            name: appName,
            appConfig: appConfig,
            activeWhen: activeWhen,
            mode: 'link',
            status: constants_1.StatusEnum.NOT_LOADED,
            customProps: customProps
        };
        apps.push(appOpt);
        window.apps = apps;
    };
    Mooa.prototype.start = function () {
        this.started = true;
        window.addEventListener('mooa.routing.navigate', function (event) {
            var opts = event.detail;
            if (opts) {
                app_helper_1.navigateAppByName(opts);
            }
        });
        return this.reRouter();
    };
    Mooa.prototype.reRouter = function (eventArguments) {
        function performAppChanges() {
            return __awaiter(this, void 0, void 0, function () {
                var unloadPromises, unmountUnloadPromises, allUnmountPromises, unmountAllPromise, appsToLoad, loadThenMountPromises, mountPromises, err_1, activeApp, eventArgs, iframeId, iframeEl;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            app_helper_1.customEvent('mooa.routing.before');
                            unloadPromises = status_helper_1.default.getAppsToUnload().map(unload_1.toUnloadPromise);
                            unmountUnloadPromises = status_helper_1.default.getAppsToUnmount(apps)
                                .map(unmount_1.toUnmountPromise)
                                .map(function (unmountPromise) { return unmountPromise.then(unload_1.toUnloadPromise); });
                            allUnmountPromises = unmountUnloadPromises.concat(unloadPromises);
                            unmountAllPromise = Promise.all(allUnmountPromises);
                            appsToLoad = status_helper_1.default.getAppsToLoad(apps);
                            loadThenMountPromises = appsToLoad.map(function (app) {
                                return load_1.toLoadPromise(app)
                                    .then(bootstrap_1.toBootstrapPromise)
                                    .then(function (toMountApp) {
                                    return __awaiter(this, void 0, void 0, function () {
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0: return [4 /*yield*/, unmountAllPromise];
                                                case 1:
                                                    _a.sent();
                                                    return [2 /*return*/, mount_1.toMountPromise(toMountApp)];
                                            }
                                        });
                                    });
                                });
                            });
                            mountPromises = status_helper_1.default.getAppsToMount(apps)
                                .filter(function (appToMount) { return appsToLoad.indexOf(appToMount) < 0; })
                                .map(function (appToMount) {
                                return __awaiter(this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, bootstrap_1.toBootstrapPromise(appToMount)];
                                            case 1:
                                                _a.sent();
                                                return [4 /*yield*/, unmountAllPromise];
                                            case 2:
                                                _a.sent();
                                                return [2 /*return*/, mount_1.toMountPromise(appToMount)];
                                        }
                                    });
                                });
                            });
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, unmountAllPromise];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            err_1 = _a.sent();
                            throw err_1;
                        case 4: return [4 /*yield*/, Promise.all(loadThenMountPromises.concat(mountPromises))];
                        case 5:
                            _a.sent();
                            if (eventArguments) {
                                activeApp = status_helper_1.default.getActiveApps(apps)[0];
                                if (activeApp && activeApp['appConfig']) {
                                    eventArgs = {
                                        url: eventArguments.url,
                                        app: activeApp['appConfig']
                                    };
                                    if (activeApp.mode === 'iframe') {
                                        iframeId = dom_utils_1.generateIFrameID(activeApp.name);
                                        iframeEl = document.getElementById(iframeId);
                                        if (iframeEl && iframeEl.contentWindow) {
                                            iframeEl.contentWindow.mooa.option = window.mooa.option;
                                            iframeEl.contentWindow.dispatchEvent(new CustomEvent('mooa.routing.change', { detail: eventArgs }));
                                        }
                                    }
                                    else {
                                        app_helper_1.customEvent('mooa.routing.change', eventArgs);
                                    }
                                }
                            }
                            return [2 /*return*/];
                    }
                });
            });
        }
        return performAppChanges();
    };
    return Mooa;
}());
exports.default = Mooa;
exports.mooaRouter = new router_1.default();
exports.mooaPlatform = new platform_1.MooaPlatform();
//# sourceMappingURL=mooa.js.map